
#ifndef __LISTA_H_
#define __LISTA_H_

template<typename T>
struct lista
{
    lista() { eleje = 0; }
    ~lista();

    int hossz() const;
    void vegere(const T&);
    T vegerol();

    void vegere_rossz(const T&);
    T vegerol_rossz();

private:
    struct elem
    {
        elem(T adat_) : adat(adat_) { kov = 0; }

        T adat;
        elem* kov;
    };


    elem* eleje;
};


template<typename T>
lista<T>::~lista()
{
    elem* akt = eleje;
    elem* atmeneti;

    while (akt)
    {
        atmeneti = akt;
        akt = akt->kov;
        delete atmeneti;
    }
}



template<typename T>
int lista<T>::hossz() const
{
    elem* akt = eleje;
    int h = 0;

    while (0 != akt)
    {
        akt = akt->kov;
        ++h;
    }

    return h;
}


template<typename T>
void lista<T>::vegere(const T& uj)
{
    elem** akt = &eleje;

    while (0 != *akt)    akt = &((*akt)->kov);

    *akt = new elem(uj);
}


template<typename T>
T lista<T>::vegerol()
{
    elem** akt = &eleje;
    while ((*akt)->kov)   akt = &((*akt)->kov);

    T adat = (*akt)->adat;
    delete (*akt);
    (*akt) = 0;

    return adat;
}



template<typename T>
void lista<T>::vegere_rossz(const T& uj)
{
// Nem jo: mivel a referencia mutatora all,
// ezert akt = akt->kov a mutatonak ad uj erteket,
// nem pedig "lepteti" a referenciat.

    elem*& akt = eleje;

    while (0 != akt)   akt = akt->kov;

    akt = new elem(uj);
}

template<typename T>
T lista<T>::vegerol_rossz()
{
    elem*& akt = eleje;
    while (akt && akt->kov)   akt = akt->kov;

    T adat = akt->adat;
    delete akt;
    akt = 0;

    return adat;
}

#endif
