
#include "verem.h"

using namespace std;

verem::verem(int hossz) : max(hossz), index(0)
{
    tomb = new int[hossz];
}

verem::~verem()
{
    delete[] tomb;
}

void verem::copy(const verem& v)
{
    max = v.max;
    index = v.index;
    tomb = new int[max];

    for (int i = 0; i < index; ++i)    tomb[i] = v.tomb[i];
}


verem::verem(const verem& v)
{
    copy(v);
}

verem& verem::operator=(const verem& v)
{
    // v = v

    if (this == &v)    return *this;

    delete[] tomb;
    copy(v);
    return *this;
}

void verem::push(int i)
{
    // spec. esetet is figyelembe kellene venni
    // ha a verem tele van
    tomb[index++] = i;
}

int verem::pop()
{
    // spec. esetet is figyelembe kellene venni
    // ha a verem ures
    return tomb[--index];
}


int verem::top() const
{
    // spec. esetet is figyelembe kellene venni
    // ha a verem ures
    return tomb[index - 1];
}


bool verem::isempty()
{
    return (index == 0);
}

bool operator>>(istream& i, verem& v)
// max index elemek...
// 6217 2 5 -6
{
    int max;
    int index;
    bool l = true;

    l = l && (i >> max);
    l = l && (i >> index);

    verem v2(max);

    for (int j = 0; j < index; ++j)
    {
        int k;
        l = l && (i >> k);
        v2.push(k);
    }

    v = v2;

    return l;
}


ostream& operator<<(ostream& o, const verem& v)
{
    for (int i = 0; i < v.index; ++i)   o << v.tomb[i];
    return o;
}
