

#include <iostream>

using namespace std;

//class complex
//{
//public:
    //int i;
//};

struct komplex
{
    komplex(double v = 0, double k = 0) : valos(v), kepzetes(k) {}
    komplex(const komplex& k);
    komplex(istream& i);

    komplex operator+(const komplex&);
    komplex operator+(int);         // k + 3
                                    // 3 + k
    komplex& operator+=(const komplex&);
    komplex& operator=(const komplex&);


    friend komplex operator+(int i, komplex& k);
    friend bool operator>>(istream& i, komplex& k);
    friend ostream& operator<<(ostream& o, komplex& k);

private:
    double valos;
    double kepzetes;
};

komplex::komplex(const komplex& k)
{
    valos = k.valos;
    kepzetes = k.kepzetes;
}


komplex operator+(int i, komplex& k)
{
    return komplex(i + k.valos, k.kepzetes);
}

bool operator>>(istream& i, komplex& k)
{
    bool l1 = (i >> k.valos);
    bool l2 = (i >> k.kepzetes);
    return l1 && l2;
}

ostream& operator<<(ostream& o, komplex& k)
{
    o << k.valos << " + " << k.kepzetes << " * i";
    ( ( (o << k.valos) << " + ") << k.kepzetes) << " * i";
    return o;
}



komplex::komplex(istream& i)
{
    i >> valos;
    i >> kepzetes;
}

komplex komplex::operator+(const komplex& k)
{
    return komplex(valos + k.valos, kepzetes + k.kepzetes);
    //komplex k2;
    //k2.valos = valos + k.valos;
    //k2.kepzetes = kepzetes + k.kepzetes;
    //return k2;
}

komplex komplex::operator+(int i)
{
    return komplex(valos + i, kepzetes);
}

komplex& komplex::operator+=(const komplex& k)
{
    valos += k.valos;
    kepzetes += k.kepzetes;
    return *this;
}

komplex& komplex::operator=(const komplex& k)
{
    if (&k != this)
    {
        valos = k.valos;
        kepzetes = k.kepzetes;
    }
    return *this;
}

int main()
{
    komplex kkk1;
    komplex kkk2(kkk1);


    komplex k(cin), k1(cin), k2(cin);

    // k.valos = 1;     // most mar private, nem lehet elerni

    k = k1 + k2;        // operator+
    k = k1.operator+( k2 );

    k = k1 + 1;
    k = 1 + k1;

    k += k2;        // operator+=

    cout << k << endl;    // operator<<

    // LISP: (+ 1 2)

    while (cin >> k)        // operator>>
    {
        cout << k << endl;    // operator<<
    }

}

